<template>
    <main class="main">
        <div class="container">
            <div class="product">
                <div class="catalog__back">
                    <a href="index.html" class="catalog__back--link">Головна ></a>
                    <a href="index.html" class="catalog__back--link"> Дитячі коляски ></a>
                </div>

                <div class="product__head">
                    <h4 class="product__name">{{ productsItem.name }}</h4>
                    <div class="product__menu">
                        <button class="btn--tofavourite">
                            <BaseIconSvg customClass="product__menu--icon" iconName="to-favorite" width="25px"
                                height="22px" color="#A5A5A5" />
                            У вибране
                        </button>
                        <button class="btn--comparison">
                            <BaseIconSvg customClass="product__menu--icon" iconName="to-comparison" width="31px"
                                height="22px" color="#A5A5A5" />
                            Порівняти
                        </button>
                    </div>
                </div>

                <div class="product__info">
                    <div class="product__availability">
                        <p class="product__availability--text">
                            В наявності
                        </p>
                    </div>
                    <div class="product__code">
                        <p class="product__code--text">
                            Код: ЕР-01
                        </p>
                    </div>
                    <div class="product__rating">
                        <p class="product__rating--text">{{ averageRating }}</p>
                        <img src="/img/Star-1.svg" alt="" class="product__rating--icon">
                        <div class="product__comment">
                            <button @click="scrollToComments" class="product__comment--btn">{{ comments.length }} відгуків</button>
                        </div>
                    </div>
                </div>

                <BaseLoader v-model="loader">
                    <div class="product__about">
                    <div class="product__images">
                        <swiper @swiper="setThumbsSwiper" :loop="true" :direction="'vertical'" :spaceBetween="10"
                            :slidesPerView="6" :freeMode="true" :modules="[FreeMode, Navigation, Thumbs]"
                            :watchSlidesProgress="true" class="mySwiper3">
                            <swiper-slide v-for="(image, index) in productsItem.images" :key="index"><img
                                    :src="image.url" :alt="image.name" class="product__photo--img"></swiper-slide>

                        </swiper>

                        <swiper :style="{'--swiper-navigation-color': '#fff','--swiper-pagination-color': '#fff',}" 
                                :loop="true" 
                                :spaceBetween="10" 
                                :navigation="{ prevEl: prev, nextEl: next}" 
                                :thumbs="{ swiper: thumbsSwiper }" 
                                :modules="[FreeMode, Navigation, Thumbs]" 
                                class="mySwiper2">
                            <swiper-slide v-for="(image, index) in productsItem.images" :key="index">
                                <img :src="image.url" :alt="image.name" class="product__photo--img">
                            </swiper-slide>

                            <div ref="prev" class="swiper-button-prev">
                                <BaseIconSvg width="20" height="20" color="#D03664" iconName="left" />
                            </div>
                            <div ref="next" class="swiper-button-next">
                                <BaseIconSvg width="20" height="20" color="#D03664" iconName="right" />
                            </div>
                        </swiper>


                    </div>
                    <div class="product__select">
                        <div class="palette">
                            <p class="palette__head">
                                Колір:
                            </p>
                            
                                <form class="palette__list">
                                    <InputRadioButton @update:modelValue="getProduct" :options="productSwitchingColor" />
                                </form>

                        </div>
                        <div class="gender">
                            <p class="gender__head">
                                Стать:
                            </p>
 
                                <form class="gender__select">
                                    <InputRadioButtonGender @update:modelValue="getProduct" :options="productSwitchingGender"/>
                                </form>
                        </div>

                        <div class="product__price">

                            <p v-if="productsItem.price_old !== '0.00'" class="product__price--old">{{productsItem.price_old}}</p>
                            <p
                                :class="['product__price--active', { 'product__price--new': productsItem.price_old !== '0.00' }]">
                                {{ productsItem.price }}</p>
                            <p v-if="productsItem.price_old !== '0.00'" class="product__price--sale">{{productsItem.discount_percent}}%</p>
                        </div>

                        <div class="product__buy">
                            <button @click="sendToCart" class="button btn--buy">
                                <img src="/img/basket.svg" alt="basket" class="user-menu__link--icon">
                                <p class="btn__buy--name">Купити</p>
                            </button>
                            <button class="button-light btn--click">
                                Купити в 1 клік
                            </button>
                        </div>

                        <div class="product__gps">
                            <p class="product__gps--head">Ви з Одеси? Заберіть товар у магазині</p>
                            <p class="product__gps--adress"><img src="/img/location.svg" alt="" class="product__gps--icon">
                                Одеса, вул. Михайлівська, 8 (10:00-19:00 щодня)
                            </p>
                            <NuxtLink to="#" class="product__gps--date">Забрати сьогодні</NuxtLink>
                        </div>
                        <ul class="support">
                            <li class="support__item"><a href="#" class="support__link">Оплата і доставка</a></li>
                            <li class="support__item"><a href="#" class="support__link">Повернення і обмін</a></li>
                            <li class="support__item"><a href="#" class="support__link">Контакти</a></li>
                        </ul>
                    </div>
                </div>
                </BaseLoader>

                <div class="sales sales--product">
                    <div class="sales__block">
                        <h4 class="section__head">З цим також купують</h4>
                        <button type="button" class="button--sale button--next">
                            <BaseIconSvg width="20" height="20" color="#D03664" iconName="right" />
                        </button>
                    </div>
                    <ProductCart :options="productsItems" />
                </div>
            </div>
        </div>
        <div class="description">
            <div class="container">
                <div class="description__content">
                    <div class="description__about">
                        <h5 class="description__head">Опис</h5>
                        <div class="description__product">
                                
                            <p v-html="productsItem.product?.body"></p>
                            <div class="brands__link"><a href="#" class="brands__description--link">Докладніше</a></div>
                        </div>
                    </div>
                    <div class="description__testimon">
                        <h5 class="description__head">Характеристики</h5>
                        <div class="description__char">
                            <div class="description__item">
                                <p class="description__item--head">Виробник</p>
                                <p class="description__item--name">{{ productsItem.specification?.Color[0]}}</p>
                            </div>
                            <div class="description__item">
                                <p class="description__item--head">Країна</p>
                                <p class="description__item--name">Польща</p>
                            </div>
                            <div class="description__item">
                                <p class="description__item--head">Колір</p>
                                <p class="description__item--name">Сірий</p>
                            </div>
                            <div class="description__item">
                                <p class="description__item--head">Стать</p>
                                <p class="description__item--name">{{ productsItem.specification?.Gender[0]}}</p>
                            </div>
                            <div class="description__item">
                                <p class="description__item--head">Вага</p>
                                <p class="description__item--name">14 кг</p>
                            </div>
                            <div class="description__item">
                                <p class="description__item--head">Розмір (ДхШхВ)</p>
                                <p class="description__item--name">108.5х60х124.5 см</p>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="box" class="description__review">
                    <div class="description__comment">
                        <h5 class="description__head description__head--response">Відгуки ({{ comments.length }})</h5>
                        <div class="product__rating">
                            <p class="product__rating--name">Рейтинг:</p>
                            <p class="product__rating--text">{{ averageRating }}</p>
                            <img src="/img/Star-1.svg" alt="Star-1" class="product__rating--icon">
                        </div>
                    </div>
                    <div v-click-out-side="customMethod"  class="description__button">
                        
                        <button class="button btn--description" @click="addReviewMethod">+ Написати відгук</button>
                        <BaseLoader v-model="loader">
                            <vee-form class="description__popup" v-if="addReview" @submit="sendComment" :validation-schema="schema">
                                <h5 class="description__head description__head--response">
                                    Ваш Відгук
                                </h5>
                                <div class="responds__rating responds__rating--popup">
                                    <p class="responds__rating--head">Оцінка:</p>

                                    <star-rating v-model:rating="formDataComment.rating" name="rating" :star-size="40"
                                        inactive-color="#fff" border-color="#C7C7C7" :show-rating="false" :border-width="2" :padding="1"
                                        active-border-color="null" active-color="#D03664"></star-rating>
                                </div>

                                <div class="responds__fields">
                                    <div class="responds__contacter">
                                        <div class="responds__contacter--block">
                                            <InputText customClass="input__contacer--info" name="name" placeholder="Ім'я"
                                            v-model="formDataComment.senderName" />
                                        </div>

                                        <div class="responds__contacter--block">
                                            <InputText customClass="input__contacer--info" type="email" name="email" placeholder="Email"
                                            v-model="formDataComment.senderEmail" />
                                        </div>
                                    </div>
                                    <!-- <textarea class="responds__review" type="text" name="body" placeholder="Ваш коментар"
                                        v-model="formDataComment.body"></textarea> -->

                                    <InputTextarea placeholder="Ваш коментар" name="body" type="text" v-model="formDataComment.body"/>

                                    <FileInput v-model:previewImg="formDataPreview.images"
                                        v-model="formDataComment.images" />

                                    <button type="submit" class="button btn__enter--respond">
                                        Залишити
                                    </button>
                                </div>
                            </vee-form>
                        </BaseLoader>
                        
                    </div>

                    <masonry-wall :items="comments" :column-width="350" :gap="30">
                        <template #default="{ item, index }">
                            <div class="responds__item">
                                <p class="responds__date">{{ $moment(item.created_at).format("DD.MM.YYYY") }}</p>
                                <div class="responds__rating">
                                    <p class="responds__rating--name">{{ item.name }}</p>
                                    <div class="responds__stars">
                                        <star-rating v-model:rating="item.rating" :star-size="20"
                                            inactive-color="#FFEAF1" read-only :show-rating="false"
                                            rounded-corners active-color="#D03664"></star-rating>
                                    </div>
                                </div>
                                <p class="responds__text">
                                    {{ item.body }}
                                </p>
                                <div class="responds__images">
                                    <img v-for="(commentImage, idx) in item.images" :key="idx" :src="commentImage?.url"
                                        alt="Responds 1" class="responds__images--item">

                                </div>
                            </div>
                        </template>
                    </masonry-wall>
                    <div v-if="comments.length > 0" class="brands__link">
                        <button @click="moreComments" class="brands__description--btn">Показати більше</button></div>
                </div>
            </div>
        </div>

        <div class="sales sales--product">
            <div class="container">
                <div class="sales__block">
                    <h4 class="section__head">Ви переглядали</h4>
                    <button type="button" class="button--sale button--next">
                        <BaseIconSvg width="20" height="20" color="#D03664" iconName="right" />
                    </button>
                </div>
                <ProductCart  />
            </div>
        </div>

    </main>
</template>

<script setup>
import { serialize } from 'object-to-formdata';
import { Swiper, SwiperSlide } from 'swiper/vue';
import { clickOutSide as vClickOutSide } from '@mahdikhashan/vue3-click-outside';
import { useForm, useField } from 'vee-validate';
import * as yup from 'yup';

// Import Swiper styles
import 'swiper/scss';

import "swiper/scss/free-mode";
import "swiper/scss/navigation";
import "swiper/scss/thumbs";
import StarRating from 'vue-star-rating';
// swiper

const prev = ref(null);
const next = ref(null);


import { FreeMode, Navigation, Thumbs } from 'swiper';

let thumbsSwiper = ref(null);

const setThumbsSwiper = (swiper) => {
    thumbsSwiper.value = swiper;
}



let productsItem = ref([]);
let comments = ref([])

const toBasket = ref({
    quantity: 1
})
const commentsPagination = ref({
    per_page: 16,

})

const productSwitchingColor = ref();
const productSwitchingGender = ref();

const cartId = useCookie("cartId");

const productId = ref('')
const commentId = ref('')
const { $snotify, moment } = useNuxtApp()
const loader = ref(false);

const route = useRoute();

components: {
    StarRating
};


let colorItems = ref([
    { id: 122, color: '#34CBFF' },
    { id: 133, color: '#FF3636' },
    { id: 144, color: '#4AFF3A' }
]);

const formDataPreview = ref({
    images: []
});


let formDataComment = ref({
    rating: String,
    body: "",
    images: []
})



let addReview = ref(false);


const averageRating = ref(null);

const schema = yup.object({
    name: yup.string().required().min(6),
    body: yup.string().required().min(10),
    email: yup.string().required().email(),
})

function scrollToComments() {
    const scrollingElement = document.querySelector("#box")

    scrollingElement.scrollIntoView({behavior: "smooth"})
}




function addReviewMethod() {
    addReview.value = !addReview.value
}

onMounted(() => {

    getProduct(route.query.slug);

})

async function getProduct(slug) {
    try {

        loader.value = true
        const data = await $api().variations.variationsGetProduct(slug);

        productSwitchingColor.value = data.switching[0].properties

        productSwitchingGender.value = data.switching[1].properties


        productsItem.value = data.data;

        console.log(productsItem)

        productId.value = data.data.id;


        const getComments = await $api().comments.getComments(data.data.product.id, commentsPagination.value);

        comments.value = getComments.data;


        commentId.value = data.data.product.id

        averageRating.value = data.data.product.rating.toFixed(1)
        
    }
    catch (e) {
        $snotify.error(e.data);
    }
    finally {
        loader.value = false
    }

}

async function sendComment() {
    try {
        loader.value = true
        const formDataCommentObject = serialize(formDataComment.value);
        const review = await $api().comments.sendComment(commentId.value, formDataCommentObject)
        getProduct()

        actions.resetForm({
        rating: "",
        body: "",
        images: []
        });
        $snotify.success("success");
    }
    catch (e) {
        actions.setErrors(e.data.errors)
        $snotify.error(e.data);
    }
    
    finally {
        loader.value = false
    }

}

async function getCarts() {
    try {
        const shopCarts = await $api().carts.getCarts()
        
        $snotify.success("success");
    }
    catch (e) {
        $snotify.error(e.data);
    }
}

async function sendToCart() {
    try {
        const addToCart = await $api().carts.addToCards(productId.value, toBasket.value)
        cartId.value = addToCart.cart_id
        getCarts()
        $snotify.success("success");
    }
    catch (e) {
        $snotify.error(e.data);
    }
}

function moreComments() {
    commentsPagination.value.per_page += 5;
    getProduct()
}

function customMethod() {
    addReview.value = false;
    formDataComment.value = {
        rating: 0,
        body: null,
        images: []
    };
      
}



</script>

